"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Wordcloud = void 0;

var _react = _interopRequireWildcard(require("react"));

var _big = _interopRequireDefault(require("big.js"));

var _core = require("@echarts-readymade/core");

var _wordcloud = _interopRequireDefault(require("wordcloud"));

var _maskCircle = _interopRequireDefault(require("./assets/mask-circle.png"));

var _maskDiamond = _interopRequireDefault(require("./assets/mask-diamond.png"));

var _maskJoy = _interopRequireDefault(require("./assets/mask-joy.png"));

var _maskGreat = _interopRequireDefault(require("./assets/mask-great.png"));

var _maskBad = _interopRequireDefault(require("./assets/mask-bad.png"));

var _maskOval = _interopRequireDefault(require("./assets/mask-oval.png"));

var _maskRect = _interopRequireDefault(require("./assets/mask-rect.png"));

var _maskCloud = _interopRequireDefault(require("./assets/mask-cloud.png"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _useRect = require("./useRect");

var _clone = _interopRequireDefault(require("clone"));

var _excluded = ["context", "dimension", "valueList", "colorList", "fontSizeMode", "wordcloudOptions", "shape", "wordcloudStop", "setOption"];

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Wrapper = _styledComponents["default"].div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 100%;\n"])));

var Wordcloud = function Wordcloud(props) {
  var context = props.context,
      dimension = props.dimension,
      valueList = props.valueList,
      colorList = props.colorList,
      _props$fontSizeMode = props.fontSizeMode,
      fontSizeMode = _props$fontSizeMode === void 0 ? 'bySort' : _props$fontSizeMode,
      wordcloudOptions = props.wordcloudOptions,
      shape = props.shape,
      wordcloudStop = props.wordcloudStop,
      setOption = props.setOption,
      restSettings = _objectWithoutProperties(props, _excluded);

  var _useContext = (0, _react.useContext)(context),
      data = _useContext.data;

  if (!data) {
    return null;
  }

  var ref = (0, _react.useRef)(null);
  var wrapperRef = (0, _react.useRef)(null);
  var wrapperRect = (0, _useRect.useRect)(wrapperRef);
  var textRef = (0, _react.useRef)(null);
  var tooltipRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isShowKeywordValueComp = _useState2[0],
      setIsShowKeywordValueComp = _useState2[1];

  var _useState3 = (0, _react.useState)({
    top: 0,
    left: 0,
    width: 0,
    height: 0
  }),
      _useState4 = _slicedToArray(_useState3, 2),
      pos = _useState4[0],
      setPos = _useState4[1];

  var _useState5 = (0, _react.useState)(''),
      _useState6 = _slicedToArray(_useState5, 2),
      val = _useState6[0],
      setVal = _useState6[1];

  var _dimension = dimension && dimension.slice(0, 1);

  var _valueList = valueList && valueList.slice(0, 1);

  if (!(_dimension && _valueList && _dimension.length > 0 && _valueList.length > 0)) {
    return null;
  }

  var getColor = (0, _react.useCallback)(function (index) {
    if (colorList && colorList.length > 0) {
      return colorList[index % colorList.length];
    } else {
      return _core.COLOR_LIST[index % _core.COLOR_LIST.length];
    }
  }, [colorList && colorList.join(',')]);
  var wordCloudCallback = (0, _react.useCallback)( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
    var sortedData, maskImage, maskCanvas, bctx, bgPixel, maskCanvasScaled, ctx, imageData, newImageData, i, bgColor, _locker, _list, _defaultOptions, options;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(!ref || !ref.current)) {
              _context2.next = 2;
              break;
            }

            return _context2.abrupt("return");

          case 2:
            sortedData = function sortedData() {
              // 按数值排序计算字体大小
              var getFontSizeBySorting = function getFontSizeBySorting(d, index) {
                var fontSizeRange = 200;
                var per = index / d.length * 100;
                var fontSize = 16;

                var _width = (wrapperRect === null || wrapperRect === void 0 ? void 0 : wrapperRect.width) || 500;

                var ratio = 1; // 如果排名第一个词的字体长度超出画布，则计算缩放比例

                if (d && d[0] && d[0][0] && d[0][0].length * 200 > _width) {
                  ratio = _width / (360 + 50);
                }

                if (index == 0) {
                  fontSize = 360;
                } else if (index == 1) {
                  fontSize = 200;
                } else if (index == 2) {
                  fontSize = 100;
                } else {
                  if (per < 10) {
                    fontSize = 60;
                  } else if (per >= 10 && per < 20) {
                    fontSize = 50;
                  } else if (per >= 20 && per < 30) {
                    fontSize = 40;
                  } else if (per >= 30 && per < 40) {
                    fontSize = 30;
                  } else if (per >= 40) {
                    fontSize = 20;
                  }
                }

                return (0, _big["default"])(fontSize * ratio).round(0).toNumber();
              };

              var fontSizeRatio = 1;
              var minFontSize = 20;
              var maxFontSize = 360;

              var getFontSize = function getFontSize(d, v, index) {
                var max = d[0][1];
                var min = d[d.length - 1][1];
                var scale = (max - min) / (maxFontSize - minFontSize);

                var _fontSize = (0, _big["default"])(v - min).div(scale).plus(minFontSize).round(0).toNumber();

                var _width = (wrapperRect === null || wrapperRect === void 0 ? void 0 : wrapperRect.width) || 500; // 如果排名第一个词的字体长度超出画布，则计算缩放比例


                if (textRef && textRef.current && index == 0) {
                  textRef.current.innerText = d[0][0];
                  textRef.current.style.fontSize = 360 + 'px';

                  if (textRef.current.clientWidth > _width) {
                    fontSizeRatio = _width / textRef.current.clientWidth;
                  }
                }

                return Math.round(_fontSize * fontSizeRatio);
              };

              var progressData = (data === null || data === void 0 ? void 0 : data.map(function (d, i) {
                var text = d[_dimension[0].fieldKey];
                var value = 0;

                if (d[_valueList[0].fieldKey]) {
                  value = (0, _big["default"])(d[_valueList[0].fieldKey]);

                  if (_valueList[0].isPercent) {
                    value = value.times(100);
                  }

                  value = value.round(_valueList[0].decimalLength || 0).toNumber();
                }

                return [text || '--', value];
              })) || []; // progressData = [
              //   ['啤酒', 39878014],
              //   ['自营', 7388903],
              //   ['青岛', 2475055],
              //   ['百威', 2454790],
              //   ['德国', 1667918],
              //   ['精酿', 1627002],
              //   [1664, 1546317],
              //   ['燕京', 1331882],
              //   ['京东超市', 1311626],
              //   ['整箱', 1282018],
              //   ['雪花', 1199154],
              //   ['乌苏', 1168907],
              //   ['哈尔滨', 981333],
              //   ['科罗娜', 873413],
              //   ['福佳', 872439],
              //   ['白啤', 857355],
              //   ['进口', 744488],
              //   ['菠萝啤', 623366],
              //   ['黑啤', 603007],
              //   ['喜力', 601554],
              //   ['小麦', 559529],
              //   ['教士', 411186],
              //   ['泰山', 392475],
              //   ['麒麟', 365579],
              //   ['柏龙', 314261],
              //   ['勇闯天涯', 300359],
              //   ['瓦伦丁', 298168],
              //   ['原浆', 289474],
              //   ['珠江', 262216],
              //   ['嘉士伯', 257401],
              //   ['小麦王', 254176],
              //   ['三得利', 245959],
              //   ['蓝妹', 235297],
              //   ['IPA', 227707],
              //   ['奥丁格', 224843],
              //   ['奥古特', 205754],
              //   ['瓶装', 202846],
              //   ['比利时', 194663],
              //   ['桶装', 192736],
              //   ['白熊', 191719],
              //   ['500ML', 168866],
              //   ['范佳乐', 165310],
              //   ['迷失海岸', 161727],
              //   ['爱士堡', 153587],
              //   ['罗斯福', 145594],
              //   ['青岛纯生', 145401],
              //   ['哈啤', 138180],
              //   ['粉象', 136496],
              //   ['林德曼', 127835],
              //   ['凯撒', 118245],
              //   ['科罗纳', 114709],
              //   ['一番榨', 114202],
              //   ['7天', 112067],
              //   ['桃红', 109009],
              //   ['秒杀', 108253],
              //   ['乐堡', 105861],
              //   ['风花雪月', 105410],
              //   [330, 103140],
              //   ['千岛湖', 103008],
              //   ['芙力', 97064],
              //   ['全麦', 95966],
              //   ['天湖', 93732],
              //   ['24听', 91857],
              //   ['保拉纳', 90790],
              //   ['听装', 88889],
              //   ['国产', 86575],
              //   ['德啤', 83950],
              //   ['鹅岛', 81538],
              //   ['百帝王', 78969],
              //   ['龙山泉', 76457],
              //   ['雪花纯生', 74749],
              //   ['智美', 72897],
              //   ['世涛', 71566],
              //   ['俄罗斯', 71369],
              //   ['干啤', 70428],
              //   ['5L', 65722],
              //   ['5.0啤酒', 63811],
              //   ['费尔德堡', 63766],
              //   ['金威', 63215],
              //   ['重庆', 62995],
              //   ['贝克', 62673],
              //   ['督威', 60467],
              //   ['鲜啤', 59729],
              //   ['青海湖', 57830],
              //   ['珠江纯生', 57137],
              //   ['广氏', 56822],
              //   ['日本', 56414],
              //   ['健力士', 55231],
              //   ['冰纯', 52766],
              //   ['凯尔特人', 49676],
              //   ['草莓', 48392],
              //   ['雪熊', 47589],
              //   ['匠心营造', 47314],
              //   ['波克', 46595],
              //   ['玫瑰', 45941],
              //   ['皮尔森', 43646],
              //   ['豪铂熊', 43527],
              //   ['斯坦根', 43523],
              //   ['特价', 42988],
              //   ['黄河', 42983],
              //   ['虎牌', 41452],
              //   ['山城', 40365],
              //   ['脸谱', 37157],
              //   ['皇冠', 36681],
              //   ['萨罗娜', 35461],
              //   ['狩猎神', 34983],
              //   [1964, 34874],
              //   ['小棕金', 32786],
              //   ['拉格', 32656],
              //   ['小瓶', 32112],
              //   ['高度', 31844],
              //   ['蓝帽', 31406],
              //   ['大跃', 30515],
              //   ['清爽', 29023],
              //   ['艾尔', 28893],
              //   ['礼盒', 28549],
              //   ['修道院', 28062],
              //   ['新疆', 25964],
              //   ['樱桃', 24164],
              //   ['鸿运当头', 24154],
              //   ['PAULANER', 24049],
              //   ['无酒精', 24000],
              //   ['熊猫', 23350],
              //   ['打嗝海狸', 22685],
              //   ['金尊', 22551],
              //   ['临期', 22544],
              //   ['铝罐', 22089],
              //   ['HOEGAARDEN', 21198],
              //   ['雪花脸谱', 20354],
              //   ['沃夫狼', 19758],
              //   ['青岛1903', 19140],
              //   ['黄啤', 18571],
              //   ['28天', 18511],
              //   ['超级波克', 18152],
              //   ['组合', 17431],
              //   ['大桶', 17038],
              //   ['无糖', 15756],
              //   ['青岛啤酒一厂', 15585],
              //   ['蓝带', 15501],
              //   ['水果啤酒', 15220],
              //   ['勇闯天涯superx', 14921],
              //   ['百香果', 13595],
              //   ['博龙', 13335],
              //   ['桃子', 13034],
              //   ['生啤', 12975],
              //   ['柠檬', 12909],
              //   ['330ml*24', 12805],
              //   ['啤酒组合', 12734],
              //   ['老米勒', 12162],
              //   ['泰国', 11968],
              //   ['五大连池', 11829],
              //   ['捷克', 11201],
              //   ['怡乐仙地', 11120],
              //   ['CASS', 11000],
              //   ['札幌', 10815],
              //   ['高大师', 10806],
              //   ['三宝乐', 10769],
              //   ['猛士', 10753],
              //   ['果味', 10525],
              //   ['婴儿肥', 10398],
              //   ['慕尼黑', 10341],
              //   ['烈性', 9552],
              //   ['淡色', 9537],
              //   ['外国', 9466],
              //   ['TIGER', 9309],
              //   ['牛奶世涛', 9136],
              //   ['印度', 8951],
              //   ['大麦', 8947],
              //   ['KAISERDOM', 8277],
              //   ['韩国', 8275],
              //   ['时代', 8117],
              //   ['LEO', 7894],
              //   ['ASAHI', 7639],
              //   ['无醇', 7548],
              //   ['夺命', 7538],
              //   ['瑞可德林', 6710],
              //   ['啤酒杯', 6621],
              //   ['马尔斯绿啤酒', 6621],
              //   ['高度数', 6568],
              //   ['西班牙', 6452],
              //   ['特级', 6370],
              //   ['水果味', 6264],
              //   ['杜威', 6070],
              //   ['帝国世涛', 5799],
              //   ['酵母型', 5721],
              //   ['金星', 5684],
              //   ['KIRIN', 5479],
              //   ['崂山', 5353],
              //   ['甜', 5328],
              //   ['三料', 5252],
              //   ['琥珀', 5123],
              //   ['VEDETT', 4929],
              //   ['女士', 4872],
              //   ['SUPER BOCK', 4439],
              //   ['开勒', 3922],
              //   ['修士', 3809],
              //   ['橙色', 3797],
              //   ['菠萝', 3752],
              //   [1998, 3500],
              //   ['特制啤酒', 3444],
              //   ['促销', 3438],
              //   ['罗森桥', 3171],
              //   ['黄鹤楼', 2957],
              //   ['洪门', 2947],
              //   ['PLUS', 2782],
              //   ['混搭', 2690],
              //   ['酒花大师', 2621],
              //   ['老挝', 2485],
              //   ['四料', 2471],
              //   ['七天鲜活', 2328],
              //   ['漓泉', 2267],
              //   ['新疆大乌苏', 2147],
              //   ['蓝带将军', 2123],
              //   ['毒蛇', 1968],
              //   ['台湾', 1869],
              //   ['荷兰', 1678],
              //   ['啤酒花', 1674],
              //   ['STOUT', 1655],
              //   ['双料', 1558],
              //   ['HB', 1432],
              //   ['扎啤', 1388],
              //   ['OJ', 1354],
              //   ['生力', 1292],
              //   ['咖啡', 1144],
              //   ['废墟', 1006],
              //   ['博克', 905],
              //   ['四海', 865],
              //   ['波特', 834],
              //   ['24度', 744],
              //   ['ROCHEFORT', 645],
              //   ['SUPERBOCK', 635],
              //   ['诱惑', 635],
              //   ['黑麦', 610],
              //   ['美式拉格', 593],
              //   ['法柔', 499],
              //   ['淡色拉格', 499],
              //   ['维森', 485],
              //   ['三只熊', 472],
              //   ['卢云堡', 425],
              //   ['PILSNER', 420],
              //   ['不含糖', 409],
              //   ['司陶特', 408],
              //   ['苦瓜', 401],
              //   ['帝都海盐', 370],
              //   ['巧克力世涛', 328],
              //   ['捷克皇家', 316],
              //   ['烈性艾尔', 316],
              //   ['百得福', 316],
              //   ['苦啤', 309],
              //   ['深色', 271],
              //   ['德国宝莱纳', 268],
              //   ['堡拉纳', 222],
              //   ['柑橘', 207],
              //   ['过桶', 185],
              //   ['格鲁特', 151],
              //   ['艾丁格', 149],
              //   ['壹号', 137],
              //   ['深色拉格', 130],
              //   ['赛松', 129],
              //   ['青岛蓝宝石', 129],
              //   ['烟熏', 109],
              //   ['麦芽味', 100],
              //   ['LAMBIC', 94],
              //   ['南瓜', 88],
              //   ['泰谷', 83],
              //   ['青西小镇', 83],
              //   ['橙色啤酒18', 79],
              //   ['ORION', 77],
              //   ['汉斯小木屋', 72],
              //   ['大星', 70],
              //   ['贵兹', 67],
              //   ['橘皮', 62],
              //   ['牡蛎', 58],
              //   ['棕色艾尔', 55],
              //   ['漓泉1998', 51],
              //   ['酿酒狗', 39],
              //   ['诱惑7号', 38],
              //   ['蛇毒', 37],
              //   ['漓泉啤酒1998', 33],
              //   ['女武神', 32],
              //   ['波罗的海', 32],
              //   ['艾帝达姆', 30],
              //   ['干世涛', 26],
              //   ['辣椒', 24],
              //   ['兰比克', 20],
              //   ['诱惑七号', 18],
              //   ['角头鲨', 17],
              //   ['诱惑9号', 14],
              //   ['ABBEY', 13],
              //   ['卡尔斯特', 13],
              //   ['自然发酵', 13],
              //   ['黄瓜', 13],
              //   ['卡斯特巧克力', 12],
              //   ['香菜', 12],
              //   ['燕麦世涛', 11]
              // ]

              var result = [];

              if (progressData && progressData.length > 0) {
                result = progressData.sort(function (a, b) {
                  return b[1] - a[1];
                });
                result = result.map(function (item, index) {
                  if (fontSizeMode === 'bySort') {
                    return [item[0], getFontSizeBySorting(result, index), item[1]];
                  } else {
                    return [item[0], getFontSize(result, item[1], index), item[1]];
                  }
                });
              } // 文字重复填充
              // if (progressData.length < FILL_LENGTH) {
              //   result = fillArray(result, FILL_LENGTH, (arr, i) => {
              //     if (arr[1] >= 60) {
              //       arr[1] = arr[1] * 0.2;
              //     }
              //     return arr;
              //   });
              // }


              return result;
            };

            maskImage = _maskJoy["default"];

            if (!(typeof shape === 'string' && shape.includes('mask-'))) {
              _context2.next = 26;
              break;
            }

            _context2.t0 = shape;
            _context2.next = _context2.t0 === 'mask-circle' ? 8 : _context2.t0 === 'mask-diamond' ? 10 : _context2.t0 === 'mask-joy' ? 12 : _context2.t0 === 'mask-great' ? 14 : _context2.t0 === 'mask-bad' ? 16 : _context2.t0 === 'mask-oval' ? 18 : _context2.t0 === 'mask-rect' ? 20 : _context2.t0 === 'mask-cloud' ? 22 : 24;
            break;

          case 8:
            maskImage = _maskCircle["default"];
            return _context2.abrupt("break", 26);

          case 10:
            maskImage = _maskDiamond["default"];
            return _context2.abrupt("break", 26);

          case 12:
            maskImage = _maskJoy["default"];
            return _context2.abrupt("break", 26);

          case 14:
            maskImage = _maskGreat["default"];
            return _context2.abrupt("break", 26);

          case 16:
            maskImage = _maskBad["default"];
            return _context2.abrupt("break", 26);

          case 18:
            maskImage = _maskOval["default"];
            return _context2.abrupt("break", 26);

          case 20:
            maskImage = _maskRect["default"];
            return _context2.abrupt("break", 26);

          case 22:
            maskImage = _maskCloud["default"];
            return _context2.abrupt("break", 26);

          case 24:
            maskImage = shape;
            return _context2.abrupt("break", 26);

          case 26:
            maskCanvas = document.createElement('canvas');

            if (!(maskImage && process.env.NODE_ENV !== 'test')) {
              _context2.next = 30;
              break;
            }

            _context2.next = 30;
            return new Promise(function (resolve, reject) {
              var img = new Image();
              img.onload = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                var ctx, _height, imageData, newImageData, i, tone, alpha;

                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        maskCanvas.width = img.width;
                        maskCanvas.height = img.height;
                        ctx = maskCanvas.getContext('2d');

                        if (ref.current && wrapperRect) {
                          ref.current.width = wrapperRect.width * 2;
                          ref.current.style.width = "".concat(wrapperRect.width, "px");
                          _height = wrapperRect.width * img.height / img.width;
                          ref.current.height = _height * 2;
                          ref.current.style.height = "".concat(_height, "px");
                        }

                        if (ctx) {
                          ctx.drawImage(img, 0, 0, img.width, img.height);
                          imageData = ctx.getImageData(0, 0, maskCanvas.width, maskCanvas.height);
                          newImageData = ctx.createImageData(imageData);

                          for (i = 0; i < imageData.data.length; i += 4) {
                            tone = imageData.data[i] + imageData.data[i + 1] + imageData.data[i + 2];
                            alpha = imageData.data[i + 3];

                            if (alpha < 128 || tone > 128 * 3) {
                              newImageData.data[i] = newImageData.data[i + 1] = newImageData.data[i + 2] = 255;
                              newImageData.data[i + 3] = 0;
                            } else {
                              newImageData.data[i] = newImageData.data[i + 1] = newImageData.data[i + 2] = 0;
                              newImageData.data[i + 3] = 255;
                            }
                          }

                          ctx.putImageData(newImageData, 0, 0);
                        }

                        resolve();

                      case 6:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));
              img.src = maskImage;
            });

          case 30:
            if (maskCanvas) {
              /* Determine bgPixel by creating
               another canvas and fill the specified background color. */
              bctx = document.createElement('canvas').getContext('2d');
              bgPixel = null;

              if (bctx) {
                bctx.fillStyle = (colorList && colorList.length > 0 ? colorList[0] : _core.COLOR_LIST[0]) + '22';
                bctx.fillRect(0, 0, 1, 1);
                bgPixel = bctx.getImageData(0, 0, 1, 1).data;
              }

              maskCanvasScaled = document.createElement('canvas');

              if (ref && ref.current) {
                maskCanvasScaled.width = ref.current.width;
                maskCanvasScaled.height = ref.current.height;
              }

              ctx = maskCanvasScaled.getContext('2d');
              imageData = null;
              newImageData = null;

              if (ctx) {
                ctx.drawImage(maskCanvas, 0, 0, maskCanvas.width, maskCanvas.height, 0, 0, maskCanvasScaled.width, maskCanvasScaled.height);

                if (ref && ref.current) {
                  imageData = ctx.getImageData(0, 0, ref.current.width, ref.current.height);
                  newImageData = ctx.createImageData(imageData);
                }
              }

              if (imageData && newImageData && bgPixel) {
                for (i = 0; i < imageData.data.length; i += 4) {
                  if (imageData.data[i + 3] > 128) {
                    newImageData.data[i] = bgPixel[0];
                    newImageData.data[i + 1] = bgPixel[1];
                    newImageData.data[i + 2] = bgPixel[2];
                    newImageData.data[i + 3] = bgPixel[3];
                  } else {
                    // This color must not be the same w/ the bgPixel.
                    newImageData.data[i] = bgPixel[0];
                    newImageData.data[i + 1] = bgPixel[1];
                    newImageData.data[i + 2] = bgPixel[2];
                    newImageData.data[i + 3] = 0;
                  }
                }

                if (ctx) {
                  ctx.putImageData(newImageData, 0, 0);

                  if (ref && ref.current) {
                    ctx = ref.current.getContext('2d');
                  }

                  if (ctx) {
                    ctx.drawImage(maskCanvasScaled, 0, 0);
                  }
                }
              }

              maskCanvasScaled = ctx = imageData = newImageData = bctx = bgPixel = null;
            }

            bgColor = (colorList && colorList.length > 0 ? colorList[0] : _core.COLOR_LIST[0]) + '22';
            _locker = null;

            if (ref.current) {
              _list = sortedData();

              if (setOption) {
                _list = setOption((0, _clone["default"])(_list));
              }

              _defaultOptions = {
                list: _list,
                gridSize: 20,
                //Math.round(100 * ref.current.clientWidth / 1024),
                fontFamily: 'Microsoft YaHei',
                fontWeight: 600,
                color: function color(word, _weight, fontSize, distance, theta) {
                  // 按colorList顺序
                  var _index = _list.findIndex(function (item) {
                    return item[0] == word;
                  });

                  var _alpha = '66';

                  if (fontSize >= 100) {
                    _alpha = 'FF';
                  } else if (fontSize < 100 && fontSize > 30) {
                    _alpha = 'AA';
                  } else {
                    _alpha = '66';
                  }

                  return getColor(_index) + _alpha;
                },
                rotateRatio: 0,
                shape: shape || 'mask-joy',
                // https://wordcloud2-js.timdream.org/shape-generator.html
                drawOutOfBound: false,
                shrinkToFit: true,
                backgroundColor: bgColor,
                // minSize: '30px',
                clearCanvas: !maskCanvas,
                abortThreshold: 1000 * 5,
                hover: function hover(item, dimension, event) {
                  if (!dimension) {
                    setIsShowKeywordValueComp(false);
                    return;
                  }

                  function getLeft(x) {
                    var _tooltipRef$current;

                    var rect = (_tooltipRef$current = tooltipRef.current) === null || _tooltipRef$current === void 0 ? void 0 : _tooltipRef$current.getRect();

                    if (rect && x + rect.width + 100 >= window.innerWidth) {
                      return (x - (x + rect.width - window.innerWidth)) / 2 - 50;
                    }

                    return x / 2;
                  }

                  setIsShowKeywordValueComp(true);
                  setPos({
                    top: dimension.y / 2 - 50,
                    left: getLeft(dimension.x),
                    width: dimension.w / 2,
                    height: dimension.h / 2
                  });
                  setVal("".concat(item[3] || item[0], ": ").concat(item[2] != null ? (0, _big["default"])(item[2]).round(2).toNumber() : '--'));

                  if (_locker) {
                    clearTimeout(_locker);
                  }

                  _locker = setTimeout(function () {
                    setIsShowKeywordValueComp(false);
                  }, 5000);
                }
              };
              options = (0, _core.mergeOption)(_defaultOptions, wordcloudOptions);
              (0, _wordcloud["default"])(ref.current, options);
            }

          case 34:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })), [_dimension && JSON.stringify(_dimension), _valueList && JSON.stringify(_valueList), getColor, // JSON.stringify(wrapperRect),
  ref.current, data, props]);
  (0, _react.useEffect)(function () {
    if (ref.current) {
      var _ref$current$getConte;

      (_ref$current$getConte = ref.current.getContext('2d')) === null || _ref$current$getConte === void 0 ? void 0 : _ref$current$getConte.clearRect(0, 0, ref.current.width, ref.current.height);
    }

    var timer = setTimeout(function () {
      wordCloudCallback();
    }, 100);
    return function () {
      _wordcloud["default"].stop();

      clearTimeout(timer);
    };
  }, [wordCloudCallback]);
  (0, _react.useEffect)(function () {
    if (wordcloudStop && ref.current) {
      ref.current.addEventListener('wordcloudstop', function () {
        wordcloudStop();
      });
    }

    return function () {
      if (wordcloudStop && ref.current) {
        ref.current.removeEventListener('wordcloudstop', function () {
          wordcloudStop();
        });
      }
    };
  }, [ref === null || ref === void 0 ? void 0 : ref.current]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, data && data.length > 0 ? /*#__PURE__*/_react["default"].createElement(Wrapper, {
    ref: wrapperRef
  }, /*#__PURE__*/_react["default"].createElement("canvas", {
    ref: ref
  }), /*#__PURE__*/_react["default"].createElement(KeywordValueComp, {
    ref: tooltipRef,
    position: pos,
    value: val,
    visible: isShowKeywordValueComp
  }), /*#__PURE__*/_react["default"].createElement("span", {
    ref: textRef,
    style: {
      display: 'none',
      visibility: 'hidden',
      position: 'absolute'
    }
  })) : null);
};

exports.Wordcloud = Wordcloud;
var KeywordValueComp = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var position = props.position,
      value = props.value,
      visible = props.visible;

  var _useState7 = (0, _react.useState)(null),
      _useState8 = _slicedToArray(_useState7, 2),
      tooltipNode = _useState8[0],
      setTooltipNode = _useState8[1];

  var tooltipRef = (0, _react.useCallback)(function (node) {
    if (node !== null) {
      setTooltipNode(node);
    }
  }, []);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      getRect: function getRect() {
        return tooltipNode === null || tooltipNode === void 0 ? void 0 : tooltipNode.getBoundingClientRect();
      }
    };
  }, [tooltipNode]);
  return /*#__PURE__*/_react["default"].createElement("span", {
    ref: tooltipRef,
    style: {
      display: visible ? 'block' : 'none',
      position: 'absolute',
      top: position.top + 'px',
      left: position.left + 'px',
      padding: '5px',
      background: 'rgba(0,0,0,.5)',
      color: '#fff',
      borderRadius: '3px',
      transition: 'all .2s ease .1s',
      fontSize: '12px',
      whiteSpace: 'nowrap'
    }
  }, value);
});